# Class VulkanLogicalDeviceCreateInfo.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanLogicalDeviceCreateInfo.Builder

Enclosing class:
  `VulkanLogicalDeviceCreateInfo`

public static final class VulkanLogicalDeviceCreateInfo.Builder extends Object
Builds instances of type `VulkanLogicalDeviceCreateInfo`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final VulkanLogicalDeviceCreateInfo.Builder`
  `addAllEnabledExtensions(Iterable<String> elements)`
  Adds elements to `enabledExtensions` list.
  `final VulkanLogicalDeviceCreateInfo.Builder`
  `addAllEnabledLayers(Iterable<String> elements)`
  Adds elements to `enabledLayers` list.
  `final VulkanLogicalDeviceCreateInfo.Builder`
  `addAllFlags(Iterable<VulkanLogicalDeviceCreateFlag> elements)`
  Adds elements to `flags` set.
  `final VulkanLogicalDeviceCreateInfo.Builder`
  `addAllQueueCreateInfos(Iterable<? extends VulkanLogicalDeviceQueueCreateInfo> elements)`
  Adds elements to `queueCreateInfos` list.
  `final VulkanLogicalDeviceCreateInfo.Builder`
  `addEnabledExtensions(String element)`
  Adds one element to `enabledExtensions` list.
  `final VulkanLogicalDeviceCreateInfo.Builder`
  `addEnabledExtensions(String... elements)`
  Adds elements to `enabledExtensions` list.
  `final VulkanLogicalDeviceCreateInfo.Builder`
  `addEnabledLayers(String element)`
  Adds one element to `enabledLayers` list.
  `final VulkanLogicalDeviceCreateInfo.Builder`
  `addEnabledLayers(String... elements)`
  Adds elements to `enabledLayers` list.
  `final VulkanLogicalDeviceCreateInfo.Builder`
  `addFlags(VulkanLogicalDeviceCreateFlag element)`
  Adds one element to `flags` set.
  `final VulkanLogicalDeviceCreateInfo.Builder`
  `addFlags(VulkanLogicalDeviceCreateFlag... elements)`
  Adds elements to `flags` set.
  `final VulkanLogicalDeviceCreateInfo.Builder`
  `addQueueCreateInfos(VulkanLogicalDeviceQueueCreateInfo element)`
  Adds one element to `queueCreateInfos` list.
  `final VulkanLogicalDeviceCreateInfo.Builder`
  `addQueueCreateInfos(VulkanLogicalDeviceQueueCreateInfo... elements)`
  Adds elements to `queueCreateInfos` list.
  `VulkanLogicalDeviceCreateInfo`
  `build()`
  Builds a new `VulkanLogicalDeviceCreateInfo`.
  `final VulkanLogicalDeviceCreateInfo.Builder`
  `from(VulkanLogicalDeviceCreateInfoType instance)`
  Fill a builder with attribute values from the provided `VulkanLogicalDeviceCreateInfoType` instance.
  `final VulkanLogicalDeviceCreateInfo.Builder`
  `setEnabledExtensions(Iterable<String> elements)`
  Sets or replaces all elements for `enabledExtensions` list.
  `final VulkanLogicalDeviceCreateInfo.Builder`
  `setEnabledLayers(Iterable<String> elements)`
  Sets or replaces all elements for `enabledLayers` list.
  `final VulkanLogicalDeviceCreateInfo.Builder`
  `setFeatures(VulkanPhysicalDeviceFeatures features)`
  Initializes the optional value `features` to features.
  `final VulkanLogicalDeviceCreateInfo.Builder`
  `setFeatures(Optional<? extends VulkanPhysicalDeviceFeatures> features)`
  Initializes the optional value `features` to features.
  `final VulkanLogicalDeviceCreateInfo.Builder`
  `setFlags(Iterable<VulkanLogicalDeviceCreateFlag> elements)`
  Sets or replaces all elements for `flags` set.
  `final VulkanLogicalDeviceCreateInfo.Builder`
  `setQueueCreateInfos(Iterable<? extends VulkanLogicalDeviceQueueCreateInfo> elements)`
  Sets or replaces all elements for `queueCreateInfos` list.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanLogicalDeviceCreateInfo.Builder from(VulkanLogicalDeviceCreateInfoType instance)
    Fill a builder with attribute values from the provided `VulkanLogicalDeviceCreateInfoType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values. Collection elements and entries will be added, not replaced.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### addFlags

    public final VulkanLogicalDeviceCreateInfo.Builder addFlags(VulkanLogicalDeviceCreateFlag element)
    Adds one element to `flags` set.
    Parameters:
      `element` - A flags element
    Returns:
      `this` builder for use in a chained invocation

  - ### addFlags

    public final VulkanLogicalDeviceCreateInfo.Builder addFlags(VulkanLogicalDeviceCreateFlag... elements)
    Adds elements to `flags` set.
    Parameters:
      `elements` - An array of flags elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setFlags

    public final VulkanLogicalDeviceCreateInfo.Builder setFlags(Iterable<VulkanLogicalDeviceCreateFlag> elements)
    Sets or replaces all elements for `flags` set.
    Parameters:
      `elements` - An iterable of flags elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addAllFlags

    public final VulkanLogicalDeviceCreateInfo.Builder addAllFlags(Iterable<VulkanLogicalDeviceCreateFlag> elements)
    Adds elements to `flags` set.
    Parameters:
      `elements` - An iterable of flags elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addQueueCreateInfos

    public final VulkanLogicalDeviceCreateInfo.Builder addQueueCreateInfos(VulkanLogicalDeviceQueueCreateInfo element)
    Adds one element to `queueCreateInfos` list.
    Parameters:
      `element` - A queueCreateInfos element
    Returns:
      `this` builder for use in a chained invocation

  - ### addQueueCreateInfos

    public final VulkanLogicalDeviceCreateInfo.Builder addQueueCreateInfos(VulkanLogicalDeviceQueueCreateInfo... elements)
    Adds elements to `queueCreateInfos` list.
    Parameters:
      `elements` - An array of queueCreateInfos elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setQueueCreateInfos

    public final VulkanLogicalDeviceCreateInfo.Builder setQueueCreateInfos(Iterable<? extends VulkanLogicalDeviceQueueCreateInfo> elements)
    Sets or replaces all elements for `queueCreateInfos` list.
    Parameters:
      `elements` - An iterable of queueCreateInfos elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addAllQueueCreateInfos

    public final VulkanLogicalDeviceCreateInfo.Builder addAllQueueCreateInfos(Iterable<? extends VulkanLogicalDeviceQueueCreateInfo> elements)
    Adds elements to `queueCreateInfos` list.
    Parameters:
      `elements` - An iterable of queueCreateInfos elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addEnabledLayers

    public final VulkanLogicalDeviceCreateInfo.Builder addEnabledLayers(String element)
    Adds one element to `enabledLayers` list.
    Parameters:
      `element` - A enabledLayers element
    Returns:
      `this` builder for use in a chained invocation

  - ### addEnabledLayers

    public final VulkanLogicalDeviceCreateInfo.Builder addEnabledLayers(String... elements)
    Adds elements to `enabledLayers` list.
    Parameters:
      `elements` - An array of enabledLayers elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setEnabledLayers

    public final VulkanLogicalDeviceCreateInfo.Builder setEnabledLayers(Iterable<String> elements)
    Sets or replaces all elements for `enabledLayers` list.
    Parameters:
      `elements` - An iterable of enabledLayers elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addAllEnabledLayers

    public final VulkanLogicalDeviceCreateInfo.Builder addAllEnabledLayers(Iterable<String> elements)
    Adds elements to `enabledLayers` list.
    Parameters:
      `elements` - An iterable of enabledLayers elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addEnabledExtensions

    public final VulkanLogicalDeviceCreateInfo.Builder addEnabledExtensions(String element)
    Adds one element to `enabledExtensions` list.
    Parameters:
      `element` - A enabledExtensions element
    Returns:
      `this` builder for use in a chained invocation

  - ### addEnabledExtensions

    public final VulkanLogicalDeviceCreateInfo.Builder addEnabledExtensions(String... elements)
    Adds elements to `enabledExtensions` list.
    Parameters:
      `elements` - An array of enabledExtensions elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setEnabledExtensions

    public final VulkanLogicalDeviceCreateInfo.Builder setEnabledExtensions(Iterable<String> elements)
    Sets or replaces all elements for `enabledExtensions` list.
    Parameters:
      `elements` - An iterable of enabledExtensions elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addAllEnabledExtensions

    public final VulkanLogicalDeviceCreateInfo.Builder addAllEnabledExtensions(Iterable<String> elements)
    Adds elements to `enabledExtensions` list.
    Parameters:
      `elements` - An iterable of enabledExtensions elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setFeatures

    public final VulkanLogicalDeviceCreateInfo.Builder setFeatures(VulkanPhysicalDeviceFeatures features)
    Initializes the optional value `features` to features.
    Parameters:
      `features` - The value for features
    Returns:
      `this` builder for chained invocation

  - ### setFeatures

    public final VulkanLogicalDeviceCreateInfo.Builder setFeatures(Optional<? extends VulkanPhysicalDeviceFeatures> features)
    Initializes the optional value `features` to features.
    Parameters:
      `features` - The value for features
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanLogicalDeviceCreateInfo build()
    Builds a new `VulkanLogicalDeviceCreateInfo`.
    Returns:
      An immutable instance of VulkanLogicalDeviceCreateInfo
    Throws:
      `IllegalStateException` - if any required attributes are missing